#!/usr/bin/env python

# -*- coding: utf-8 -*-

import os
import sys
import shutil

from osgeo import gdal
from osgeo import gnm

NETWORK_PATH = '/tmp'
NETWORK_NAME = 'test'

driver = gdal.GetDriverByName('GNMFile')
options = ['net_srs=EPSG:32733',
           'net_name={}'.format(NETWORK_NAME),
           'net_description=test network'
          ]

ds = driver.Create(NETWORK_PATH, 0, 0, 0, gdal.GDT_Unknown, options)

data = gdal.OpenEx('roads.gml', gdal.OF_VECTOR)
layer = data.GetLayerByIndex(0)
roads_layer = ds.CopyLayer(layer, 'roads')
data = None

data = gdal.OpenEx('nodes.gml', gdal.OF_VECTOR)
layer = data.GetLayerByIndex(0)
nodes_layer = ds.CopyLayer(layer, 'nodes')
data = None
ds = None


ds = gdal.OpenEx(os.path.join(NETWORK_PATH, NETWORK_NAME))
network = gnm.CastToGenericNetwork(ds)
res = network.ConnectPointsByLines(['roads', 'nodes'], 0.000001, 1, 1, gnm.GNM_EDGE_DIR_BOTH)
if res != 0:
    print 'Failed to connect nodes and edges'
    sys.exit()
network = None
ds = None


ds = gdal.OpenEx(os.path.join(NETWORK_PATH, NETWORK_NAME))
network = gnm.CastToNetwork(ds)
layer = network.GetPath(251, 126, gnm.GATDijkstraShortestPath)
if layer is None:
    print 'Failed to calculate shortest path'
    sys.exit()

if layer.GetFeatureCount() == 0:
    network.ReleaseResultSet(layer)
    print 'No features in the output layer'
    sys.exit()

network.ReleaseResultSet(layer)

network = None
ds = None
